/* A Bison parser, made by GNU Bison 2.6.1.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.6.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 336 of yacc.c  */
#line 16 "gram.y"

/*
 *  pmlogrewrite parser
 */
#include "pmapi.h"
#include "impl.h"
#include "logger.h"
#include <errno.h>
#include <assert.h>

static indomspec_t	*current_indomspec;
static int		current_star_indom;
static int		do_walk_indom;
static int		star_domain;

static metricspec_t	*current_metricspec;
static int		current_star_metric;
static int		star_cluster;
static int		do_walk_metric;
static int		output = OUTPUT_ALL;
static int		one_inst;
static char		*one_name;

indomspec_t *
walk_indom(int mode)
{
    static indomspec_t	*ip;

    if (do_walk_indom) {
	if (mode == W_START)
	    ip = indom_root;
	else
	    ip = ip->i_next;
	while (ip != NULL && pmInDom_domain(ip->old_indom) != star_domain)
	    ip = ip->i_next;
    }
    else {
	if (mode == W_START)
	    ip = current_indomspec;
	else
	    ip = NULL;
    }

    return ip;
}

metricspec_t *
walk_metric(int mode, int flag, char *which)
{
    static metricspec_t	*mp;

    if (do_walk_metric) {
	if (mode == W_START)
	    mp = metric_root;
	else
	    mp = mp->m_next;
	while (mp != NULL) {
	    if (pmid_domain(mp->old_desc.pmid) == star_domain &&
		(star_cluster == PM_ID_NULL || star_cluster == pmid_cluster(mp->old_desc.pmid)))
		break;
	    mp = mp->m_next;
	}
    }
    else {
	if (mode == W_START)
	    mp = current_metricspec;
	else
	    mp = NULL;
    }

    if (mp != NULL) {
	if (mp->flags & flag) {
	    snprintf(mess, sizeof(mess), "Duplicate %s clause for metric %s", which, mp->old_name);
	    yyerror(mess);
	}
	if (flag != METRIC_DELETE) {
	    if (mp->flags & METRIC_DELETE) {
		snprintf(mess, sizeof(mess), "Conflicting %s clause for deleted metric %s", which, mp->old_name);
		yyerror(mess);
	    }
	}
	else {
	    if (mp->flags & (~METRIC_DELETE)) {
		snprintf(mess, sizeof(mess), "Conflicting delete and other clauses for metric %s", mp->old_name);
		yyerror(mess);
	    }
	}
    }

    return mp;
}


/* Line 336 of yacc.c  */
#line 162 "gram.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.tab.h".  */
#ifndef YY_GRAM_TAB_H
# define YY_GRAM_TAB_H
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_LBRACE = 258,
     TOK_RBRACE = 259,
     TOK_PLUS = 260,
     TOK_MINUS = 261,
     TOK_COLON = 262,
     TOK_COMMA = 263,
     TOK_ASSIGN = 264,
     TOK_GLOBAL = 265,
     TOK_INDOM = 266,
     TOK_METRIC = 267,
     TOK_HOSTNAME = 268,
     TOK_TZ = 269,
     TOK_TIME = 270,
     TOK_NAME = 271,
     TOK_INST = 272,
     TOK_INAME = 273,
     TOK_DELETE = 274,
     TOK_PMID = 275,
     TOK_NULL_INT = 276,
     TOK_TYPE = 277,
     TOK_SEM = 278,
     TOK_UNITS = 279,
     TOK_OUTPUT = 280,
     TOK_RESCALE = 281,
     TOK_GNAME = 282,
     TOK_NUMBER = 283,
     TOK_STRING = 284,
     TOK_HNAME = 285,
     TOK_FLOAT = 286,
     TOK_INDOM_STAR = 287,
     TOK_PMID_INT = 288,
     TOK_PMID_STAR = 289,
     TOK_TYPE_NAME = 290,
     TOK_SEM_NAME = 291,
     TOK_SPACE_NAME = 292,
     TOK_TIME_NAME = 293,
     TOK_COUNT_NAME = 294,
     TOK_OUTPUT_TYPE = 295
   };
#endif
/* Tokens.  */
#define TOK_LBRACE 258
#define TOK_RBRACE 259
#define TOK_PLUS 260
#define TOK_MINUS 261
#define TOK_COLON 262
#define TOK_COMMA 263
#define TOK_ASSIGN 264
#define TOK_GLOBAL 265
#define TOK_INDOM 266
#define TOK_METRIC 267
#define TOK_HOSTNAME 268
#define TOK_TZ 269
#define TOK_TIME 270
#define TOK_NAME 271
#define TOK_INST 272
#define TOK_INAME 273
#define TOK_DELETE 274
#define TOK_PMID 275
#define TOK_NULL_INT 276
#define TOK_TYPE 277
#define TOK_SEM 278
#define TOK_UNITS 279
#define TOK_OUTPUT 280
#define TOK_RESCALE 281
#define TOK_GNAME 282
#define TOK_NUMBER 283
#define TOK_STRING 284
#define TOK_HNAME 285
#define TOK_FLOAT 286
#define TOK_INDOM_STAR 287
#define TOK_PMID_INT 288
#define TOK_PMID_STAR 289
#define TOK_TYPE_NAME 290
#define TOK_SEM_NAME 291
#define TOK_SPACE_NAME 292
#define TOK_TIME_NAME 293
#define TOK_COUNT_NAME 294
#define TOK_OUTPUT_TYPE 295



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 350 of yacc.c  */
#line 110 "gram.y"

    char		*str;
    int			ival;
    double		dval;
    pmInDom		indom;
    pmID		pmid;


/* Line 350 of yacc.c  */
#line 294 "gram.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE yylval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_GRAM_TAB_H  */

/* Copy the second part of user declarations.  */

/* Line 353 of yacc.c  */
#line 322 "gram.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  19
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   109

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  41
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  29
/* YYNRULES -- Number of rules.  */
#define YYNRULES  96
/* YYNRULES -- Number of states.  */
#define YYNSTATES  126

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   295

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,    10,    12,    14,    16,    21,
      25,    27,    30,    34,    38,    42,    45,    47,    50,    52,
      55,    57,    59,    61,    63,    65,    68,    71,    73,    75,
      77,    80,    83,    85,    91,    97,   101,   105,   107,   109,
     110,   117,   119,   121,   123,   125,   126,   128,   131,   135,
     140,   145,   150,   155,   158,   160,   164,   167,   169,   173,
     176,   178,   179,   186,   188,   190,   192,   194,   196,   198,
     199,   201,   204,   208,   212,   216,   221,   225,   240,   242,
     245,   248,   251,   254,   257,   260,   269,   280,   293,   295,
     297,   301,   305,   308,   310,   311,   313
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      42,     0,    -1,    43,    -1,    44,    -1,    44,    43,    -1,
      45,    -1,    54,    -1,    60,    -1,    10,     3,    46,     4,
      -1,    10,     3,     4,    -1,    47,    -1,    47,    46,    -1,
      13,     9,    48,    -1,    14,     9,    29,    -1,    15,     9,
      52,    -1,    13,     9,    -1,    13,    -1,    14,     9,    -1,
      14,    -1,    15,     9,    -1,    15,    -1,    30,    -1,    27,
      -1,    28,    -1,    31,    -1,     5,    28,    -1,     6,    28,
      -1,    28,    -1,    28,    -1,    31,    -1,     5,    53,    -1,
       6,    53,    -1,    53,    -1,    50,     7,    50,     7,    51,
      -1,    50,     7,    50,     7,    50,    -1,    50,     7,    51,
      -1,    50,     7,    50,    -1,    51,    -1,    50,    -1,    -1,
      11,    56,    55,     3,    57,     4,    -1,    11,    -1,    31,
      -1,    32,    -1,    58,    -1,    -1,    59,    -1,    59,    58,
      -1,    11,     9,    56,    -1,    18,    29,     9,    29,    -1,
      18,    29,     9,    19,    -1,    17,    50,     9,    50,    -1,
      17,    50,     9,    19,    -1,    11,     9,    -1,    11,    -1,
      18,    29,     9,    -1,    18,    29,    -1,    18,    -1,    17,
      50,     9,    -1,    17,    50,    -1,    17,    -1,    -1,    12,
      62,    61,     3,    64,     4,    -1,    12,    -1,    63,    -1,
      27,    -1,    33,    -1,    34,    -1,    65,    -1,    -1,    66,
      -1,    66,    65,    -1,    20,     9,    63,    -1,    16,     9,
      27,    -1,    22,     9,    35,    -1,    11,     9,    67,    68,
      -1,    23,     9,    36,    -1,    24,     9,    49,     8,    49,
       8,    49,     8,    37,     8,    38,     8,    39,    69,    -1,
      19,    -1,    20,     9,    -1,    16,     9,    -1,    22,     9,
      -1,    11,     9,    -1,    23,     9,    -1,    24,     9,    -1,
      24,     9,    49,     8,    49,     8,    49,     8,    -1,    24,
       9,    49,     8,    49,     8,    49,     8,    37,     8,    -1,
      24,     9,    49,     8,    49,     8,    49,     8,    37,     8,
      38,     8,    -1,    56,    -1,    21,    -1,    25,    17,    50,
      -1,    25,    18,    29,    -1,    25,    40,    -1,    25,    -1,
      -1,    26,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   156,   156,   159,   160,   163,   164,   165,   168,   169,
     172,   173,   176,   195,   214,   230,   235,   240,   245,   250,
     255,   268,   269,   270,   271,   274,   279,   284,   291,   298,
     305,   306,   307,   310,   323,   335,   348,   360,   369,   381,
     380,   402,   409,   431,   445,   446,   449,   450,   453,   477,
     487,   496,   504,   512,   517,   522,   527,   532,   537,   542,
     547,   555,   554,   586,   593,   594,   612,   636,   662,   663,
     666,   667,   670,   694,   718,   746,   820,   837,   883,   890,
     895,   900,   905,   910,   915,   920,   925,   930,   937,   938,
     944,   950,   956,   960,   965,   968,   970
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_LBRACE", "TOK_RBRACE", "TOK_PLUS",
  "TOK_MINUS", "TOK_COLON", "TOK_COMMA", "TOK_ASSIGN", "TOK_GLOBAL",
  "TOK_INDOM", "TOK_METRIC", "TOK_HOSTNAME", "TOK_TZ", "TOK_TIME",
  "TOK_NAME", "TOK_INST", "TOK_INAME", "TOK_DELETE", "TOK_PMID",
  "TOK_NULL_INT", "TOK_TYPE", "TOK_SEM", "TOK_UNITS", "TOK_OUTPUT",
  "TOK_RESCALE", "TOK_GNAME", "TOK_NUMBER", "TOK_STRING", "TOK_HNAME",
  "TOK_FLOAT", "TOK_INDOM_STAR", "TOK_PMID_INT", "TOK_PMID_STAR",
  "TOK_TYPE_NAME", "TOK_SEM_NAME", "TOK_SPACE_NAME", "TOK_TIME_NAME",
  "TOK_COUNT_NAME", "TOK_OUTPUT_TYPE", "$accept", "config", "speclist",
  "spec", "globalspec", "globaloptlist", "globalopt", "hname",
  "signnumber", "number", "float", "signtime", "time", "indomspec", "$@1",
  "indom_int", "optindomopt", "indomoptlist", "indomopt", "metricspec",
  "$@2", "pmid_or_name", "pmid_int", "optmetricoptlist", "metricoptlist",
  "metricopt", "null_or_indom", "pick", "rescaleopt", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    41,    42,    43,    43,    44,    44,    44,    45,    45,
      46,    46,    47,    47,    47,    47,    47,    47,    47,    47,
      47,    48,    48,    48,    48,    49,    49,    49,    50,    51,
      52,    52,    52,    53,    53,    53,    53,    53,    53,    55,
      54,    54,    56,    56,    57,    57,    58,    58,    59,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    61,    60,    60,    62,    62,    63,    63,    64,    64,
      65,    65,    66,    66,    66,    66,    66,    66,    66,    66,
      66,    66,    66,    66,    66,    66,    66,    66,    67,    67,
      68,    68,    68,    68,    68,    69,    69
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     2,     1,     1,     1,     4,     3,
       1,     2,     3,     3,     3,     2,     1,     2,     1,     2,
       1,     1,     1,     1,     1,     2,     2,     1,     1,     1,
       2,     2,     1,     5,     5,     3,     3,     1,     1,     0,
       6,     1,     1,     1,     1,     0,     1,     2,     3,     4,
       4,     4,     4,     2,     1,     3,     2,     1,     3,     2,
       1,     0,     6,     1,     1,     1,     1,     1,     1,     0,
       1,     2,     3,     3,     3,     4,     3,    14,     1,     2,
       2,     2,     2,     2,     2,     8,    10,    12,     1,     1,
       3,     3,     2,     1,     0,     1,     0
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,    41,    63,     0,     2,     3,     5,     6,     7,
       0,    42,    43,    39,    65,    66,    67,    61,    64,     1,
       4,     9,    16,    18,    20,     0,    10,     0,     0,    15,
      17,    19,     8,    11,    45,    69,    22,    23,    21,    24,
      12,    13,     0,     0,    28,    29,    38,    37,    14,    32,
      54,    60,    57,     0,    44,    46,     0,     0,    78,     0,
       0,     0,     0,     0,    68,    70,    30,    31,     0,    53,
      59,    56,    40,    47,    82,    80,    79,    81,    83,    84,
      62,    71,    36,    35,    48,    58,    55,    89,    88,    94,
      73,    72,    74,    76,     0,     0,    27,     0,     0,    52,
      51,    50,    49,    93,    75,    25,    26,     0,    34,    33,
       0,     0,    92,     0,    90,    91,     0,     0,    85,     0,
      86,     0,    87,    96,    95,    77
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     4,     5,     6,     7,    25,    26,    40,    97,    46,
      47,    48,    49,     8,    27,    13,    53,    54,    55,     9,
      28,    17,    18,    63,    64,    65,    89,   104,   125
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -96
static const yytype_int8 yypact[] =
{
      45,    30,    32,   -19,    39,   -96,    45,   -96,   -96,   -96,
      22,   -96,   -96,   -96,   -96,   -96,   -96,   -96,   -96,   -96,
     -96,   -96,    37,    40,    43,    54,    47,    62,    67,    23,
      42,    -3,   -96,   -96,    27,     0,   -96,   -96,   -96,   -96,
     -96,   -96,   -18,   -18,   -96,   -96,    65,   -96,   -96,   -96,
      64,    46,    48,    71,   -96,    27,    69,    70,   -96,    72,
      73,    74,    75,    76,   -96,     0,   -96,   -96,   -18,    32,
      77,    78,   -96,   -96,     9,    49,    33,    50,    52,    -1,
     -96,   -96,    82,   -96,   -96,   -10,    13,   -96,   -96,    66,
     -96,   -96,   -96,   -96,    68,    79,   -96,    84,   -18,   -96,
     -96,   -96,   -96,   -11,   -96,   -96,   -96,    -1,   -96,   -96,
      46,    61,   -96,    85,   -96,   -96,    -1,    86,    58,    89,
      60,    91,    63,    80,   -96,   -96
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -96,   -96,    94,   -96,   -96,    83,   -96,   -96,   -95,   -51,
     -67,   -96,    26,   -96,   -96,   -26,   -96,    53,   -96,   -96,
     -96,   -96,    25,   -96,    38,   -96,   -96,   -96,   -96
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      70,    83,    42,    43,    94,    95,   110,   111,    14,    99,
      44,    56,   113,    45,    15,    16,    57,    82,    44,    58,
      59,   117,    60,    61,    62,    44,    21,    96,    45,   112,
      87,   109,   101,    10,   100,    22,    23,    24,    50,    19,
      11,    12,   102,    84,    51,    52,    29,   108,    88,    30,
      36,    37,    31,    38,    39,     1,     2,     3,    32,   114,
      22,    23,    24,    11,    12,    34,    15,    16,    66,    67,
      35,    41,    68,    69,    44,    72,    90,    71,    74,    75,
      80,    76,    77,    78,    79,    92,    85,    86,    93,    98,
     115,   103,   107,   116,   118,   119,   105,   120,   121,   122,
      20,    91,   123,    81,     0,     0,   124,   106,    73,    33
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-96))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int8 yycheck[] =
{
      51,    68,     5,     6,     5,     6,    17,    18,    27,    19,
      28,    11,   107,    31,    33,    34,    16,    68,    28,    19,
      20,   116,    22,    23,    24,    28,     4,    28,    31,    40,
      21,    98,    19,     3,    85,    13,    14,    15,    11,     0,
      31,    32,    29,    69,    17,    18,     9,    98,    74,     9,
      27,    28,     9,    30,    31,    10,    11,    12,     4,   110,
      13,    14,    15,    31,    32,     3,    33,    34,    42,    43,
       3,    29,     7,     9,    28,     4,    27,    29,     9,     9,
       4,     9,     9,     9,     9,    35,     9,     9,    36,     7,
      29,    25,     8,     8,     8,    37,    28,     8,    38,     8,
       6,    76,    39,    65,    -1,    -1,    26,    28,    55,    26
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    10,    11,    12,    42,    43,    44,    45,    54,    60,
       3,    31,    32,    56,    27,    33,    34,    62,    63,     0,
      43,     4,    13,    14,    15,    46,    47,    55,    61,     9,
       9,     9,     4,    46,     3,     3,    27,    28,    30,    31,
      48,    29,     5,     6,    28,    31,    50,    51,    52,    53,
      11,    17,    18,    57,    58,    59,    11,    16,    19,    20,
      22,    23,    24,    64,    65,    66,    53,    53,     7,     9,
      50,    29,     4,    58,     9,     9,     9,     9,     9,     9,
       4,    65,    50,    51,    56,     9,     9,    21,    56,    67,
      27,    63,    35,    36,     5,     6,    28,    49,     7,    19,
      50,    19,    29,    25,    68,    28,    28,     8,    50,    51,
      17,    18,    40,    49,    50,    29,     8,    49,     8,    37,
       8,    38,     8,    39,    26,    69
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])



/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 12:
/* Line 1787 of yacc.c  */
#line 177 "gram.y"
    {
			if (global.flags & GLOBAL_CHANGE_HOSTNAME) {
			    snprintf(mess, sizeof(mess), "Duplicate global hostname clause");
			    yyerror(mess);
			}
			if (strcmp(inarch.label.ll_hostname, (yyvsp[(3) - (3)].str)) == 0) {
			    /* no change ... */
			    if (wflag) {
				snprintf(mess, sizeof(mess), "Global hostname (%s): No change", inarch.label.ll_hostname);
				yywarn(mess);
			    }
			}
			else {
			    strncpy(global.hostname, (yyvsp[(3) - (3)].str), sizeof(global.hostname));
			    global.flags |= GLOBAL_CHANGE_HOSTNAME;
			}
			free((yyvsp[(3) - (3)].str));
		    }
    break;

  case 13:
/* Line 1787 of yacc.c  */
#line 196 "gram.y"
    {
			if (global.flags & GLOBAL_CHANGE_TZ) {
			    snprintf(mess, sizeof(mess), "Duplicate global tz clause");
			    yyerror(mess);
			}
			if (strcmp(inarch.label.ll_tz, (yyvsp[(3) - (3)].str)) == 0) {
			    /* no change ... */
			    if (wflag) {
				snprintf(mess, sizeof(mess), "Global timezone (%s): No change", inarch.label.ll_tz);
				yywarn(mess);
			    }
			}
			else {
			    strncpy(global.tz, (yyvsp[(3) - (3)].str), sizeof(global.tz));
			    global.flags |= GLOBAL_CHANGE_TZ;
			}
			free((yyvsp[(3) - (3)].str));
		    }
    break;

  case 14:
/* Line 1787 of yacc.c  */
#line 215 "gram.y"
    {
			if (global.flags & GLOBAL_CHANGE_TIME) {
			    snprintf(mess, sizeof(mess), "Duplicate global time clause");
			    yyerror(mess);
			}
			if (global.time.tv_sec == 0 && global.time.tv_usec == 0) {
			    /* no change ... */
			    if (wflag) {
				snprintf(mess, sizeof(mess), "Global time: No change");
				yywarn(mess);
			    }
			}
			else
			    global.flags |= GLOBAL_CHANGE_TIME;
		    }
    break;

  case 15:
/* Line 1787 of yacc.c  */
#line 231 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting hostname in hostname clause");
			yyerror(mess);
		    }
    break;

  case 16:
/* Line 1787 of yacc.c  */
#line 236 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting -> in hostname clause");
			yyerror(mess);
		    }
    break;

  case 17:
/* Line 1787 of yacc.c  */
#line 241 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting timezone string in tz clause");
			yyerror(mess);
		    }
    break;

  case 18:
/* Line 1787 of yacc.c  */
#line 246 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting -> in tz clause");
			yyerror(mess);
		    }
    break;

  case 19:
/* Line 1787 of yacc.c  */
#line 251 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting delta of the form [+-][HH:[MM:]]SS[.d...] in time clause");
			yyerror(mess);
		    }
    break;

  case 20:
/* Line 1787 of yacc.c  */
#line 256 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting -> in time clause");
			yyerror(mess);
		    }
    break;

  case 25:
/* Line 1787 of yacc.c  */
#line 275 "gram.y"
    {
			(yyval.ival) = atoi((yyvsp[(2) - (2)].str));
			free((yyvsp[(2) - (2)].str));
		    }
    break;

  case 26:
/* Line 1787 of yacc.c  */
#line 280 "gram.y"
    {
			(yyval.ival) = -atoi((yyvsp[(2) - (2)].str));
			free((yyvsp[(2) - (2)].str));
		    }
    break;

  case 27:
/* Line 1787 of yacc.c  */
#line 285 "gram.y"
    {
			(yyval.ival) = atoi((yyvsp[(1) - (1)].str));
			free((yyvsp[(1) - (1)].str));
		    }
    break;

  case 28:
/* Line 1787 of yacc.c  */
#line 292 "gram.y"
    {
			(yyval.ival) = atoi((yyvsp[(1) - (1)].str));
			free((yyvsp[(1) - (1)].str));
		    }
    break;

  case 29:
/* Line 1787 of yacc.c  */
#line 299 "gram.y"
    {
			(yyval.dval) = atof((yyvsp[(1) - (1)].str));
			free((yyvsp[(1) - (1)].str));
		    }
    break;

  case 31:
/* Line 1787 of yacc.c  */
#line 306 "gram.y"
    { global.time.tv_sec = -global.time.tv_sec; }
    break;

  case 33:
/* Line 1787 of yacc.c  */
#line 311 "gram.y"
    { 
			if ((yyvsp[(3) - (5)].ival) > 59) {
			    snprintf(mess, sizeof(mess), "Minutes (%d) in time clause more than 59", (yyvsp[(3) - (5)].ival));
			    yywarn(mess);
			}
			if ((yyvsp[(5) - (5)].dval) > 59) {
			    snprintf(mess, sizeof(mess), "Seconds (%.6f) in time clause more than 59", (yyvsp[(5) - (5)].dval));
			    yywarn(mess);
			}
			global.time.tv_sec = (yyvsp[(1) - (5)].ival) * 3600 + (yyvsp[(3) - (5)].ival) * 60 + (int)(yyvsp[(5) - (5)].dval);
			global.time.tv_usec = (int)(1000000*(((yyvsp[(5) - (5)].dval) - (int)(yyvsp[(5) - (5)].dval)))+0.5);
		    }
    break;

  case 34:
/* Line 1787 of yacc.c  */
#line 324 "gram.y"
    { 
			if ((yyvsp[(3) - (5)].ival) > 59) {
			    snprintf(mess, sizeof(mess), "Minutes (%d) in time clause more than 59", (yyvsp[(3) - (5)].ival));
			    yywarn(mess);
			}
			if ((yyvsp[(5) - (5)].ival) > 59) {
			    snprintf(mess, sizeof(mess), "Seconds (%d) in time clause more than 59", (yyvsp[(5) - (5)].ival));
			    yywarn(mess);
			}
			global.time.tv_sec = (yyvsp[(1) - (5)].ival) * 3600 + (yyvsp[(3) - (5)].ival) * 60 + (yyvsp[(5) - (5)].ival);
		    }
    break;

  case 35:
/* Line 1787 of yacc.c  */
#line 336 "gram.y"
    { 
			if ((yyvsp[(1) - (3)].ival) > 59) {
			    snprintf(mess, sizeof(mess), "Minutes (%d) in time clause more than 59", (yyvsp[(1) - (3)].ival));
			    yywarn(mess);
			}
			if ((yyvsp[(3) - (3)].dval) > 59) {
			    snprintf(mess, sizeof(mess), "Seconds (%.6f) in time clause more than 59", (yyvsp[(3) - (3)].dval));
			    yywarn(mess);
			}
			global.time.tv_sec = (yyvsp[(1) - (3)].ival) * 60 + (int)(yyvsp[(3) - (3)].dval);
			global.time.tv_usec = (int)(1000000*(((yyvsp[(3) - (3)].dval) - (int)(yyvsp[(3) - (3)].dval)))+0.5);
		    }
    break;

  case 36:
/* Line 1787 of yacc.c  */
#line 349 "gram.y"
    { 
			if ((yyvsp[(1) - (3)].ival) > 59) {
			    snprintf(mess, sizeof(mess), "Minutes (%d) in time clause more than 59", (yyvsp[(1) - (3)].ival));
			    yywarn(mess);
			}
			if ((yyvsp[(3) - (3)].ival) > 59) {
			    snprintf(mess, sizeof(mess), "Seconds (%d) in time clause more than 59", (yyvsp[(3) - (3)].ival));
			    yywarn(mess);
			}
			global.time.tv_sec = (yyvsp[(1) - (3)].ival) * 60 + (yyvsp[(3) - (3)].ival);
		    }
    break;

  case 37:
/* Line 1787 of yacc.c  */
#line 361 "gram.y"
    {
			if ((yyvsp[(1) - (1)].dval) > 59) {
			    snprintf(mess, sizeof(mess), "Seconds (%.6f) in time clause more than 59", (yyvsp[(1) - (1)].dval));
			    yywarn(mess);
			}
			global.time.tv_sec = (int)(yyvsp[(1) - (1)].dval);
			global.time.tv_usec = (int)(1000000*(((yyvsp[(1) - (1)].dval) - (int)(yyvsp[(1) - (1)].dval)))+0.5);
		    }
    break;

  case 38:
/* Line 1787 of yacc.c  */
#line 370 "gram.y"
    {
			if ((yyvsp[(1) - (1)].ival) > 59) {
			    snprintf(mess, sizeof(mess), "Seconds (%d) in time clause more than 59", (yyvsp[(1) - (1)].ival));
			    yywarn(mess);
			}
			global.time.tv_sec = (yyvsp[(1) - (1)].ival);
			global.time.tv_usec = 0;
		    }
    break;

  case 39:
/* Line 1787 of yacc.c  */
#line 381 "gram.y"
    {
			if (current_star_indom) {
			    __pmContext		*ctxp;
			    __pmHashCtl		*hcp;
			    __pmHashNode	*this;
			    ctxp = __pmHandleToPtr(pmWhichContext());
			    assert(ctxp != NULL);
			    hcp = &ctxp->c_archctl->ac_log->l_hashindom;
			    star_domain = pmInDom_domain((yyvsp[(2) - (2)].indom));
			    for (this = __pmHashWalk(hcp, W_START); this != NULL; this = __pmHashWalk(hcp, W_NEXT)) {
				if (pmInDom_domain((pmInDom)(this->key)) == star_domain)
				    current_indomspec = start_indom((pmInDom)(this->key));
			    }
			    do_walk_indom = 1;
			}
			else {
			    current_indomspec = start_indom((yyvsp[(2) - (2)].indom));
			    do_walk_indom = 0;
			}
		    }
    break;

  case 41:
/* Line 1787 of yacc.c  */
#line 403 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting <domain>.<serial> or <domain>.* in indom rule");
			yyerror(mess);
		    }
    break;

  case 42:
/* Line 1787 of yacc.c  */
#line 410 "gram.y"
    {
			int		domain;
			int		serial;
			int		sts;
			sts = sscanf((yyvsp[(1) - (1)].str), "%d.%d", &domain, &serial);
			if (sts < 2) {
			    snprintf(mess, sizeof(mess), "Missing serial field for indom");
			    yyerror(mess);
			}
			if (domain < 1 || domain >= DYNAMIC_PMID) {
			    snprintf(mess, sizeof(mess), "Illegal domain field (%d) for indom", domain);
			    yyerror(mess);
			}
			if (serial < 0 || serial >= 4194304) {
			    snprintf(mess, sizeof(mess), "Illegal serial field (%d) for indom", serial);
			    yyerror(mess);
			}
			current_star_indom = 0;
			free((yyvsp[(1) - (1)].str));
			(yyval.indom) = pmInDom_build(domain, serial);
		    }
    break;

  case 43:
/* Line 1787 of yacc.c  */
#line 432 "gram.y"
    {
			int		domain;
			sscanf((yyvsp[(1) - (1)].str), "%d.", &domain);
			if (domain < 1 || domain >= DYNAMIC_PMID) {
			    snprintf(mess, sizeof(mess), "Illegal domain field (%d) for indom", domain);
			    yyerror(mess);
			}
			current_star_indom = 1;
			free((yyvsp[(1) - (1)].str));
			(yyval.indom) = pmInDom_build(domain, 0);
		    }
    break;

  case 48:
/* Line 1787 of yacc.c  */
#line 454 "gram.y"
    {
			indomspec_t	*ip;
			for (ip = walk_indom(W_START); ip != NULL; ip = walk_indom(W_NEXT)) {
			    pmInDom	indom;
			    if (indom_root->new_indom != indom_root->old_indom) {
				snprintf(mess, sizeof(mess), "Duplicate indom clause for indom %s", pmInDomStr(indom_root->old_indom));
				yyerror(mess);
			    }
			    if (current_star_indom)
				indom = pmInDom_build(pmInDom_domain((yyvsp[(3) - (3)].indom)), pmInDom_serial(ip->old_indom));
			    else
				indom = (yyvsp[(3) - (3)].indom);
			    if (indom != ip->old_indom)
				ip->new_indom = indom;
			    else {
				/* no change ... */
				if (wflag) {
				    snprintf(mess, sizeof(mess), "Instance domain %s: indom: No change", pmInDomStr(ip->old_indom));
				    yywarn(mess);
				}
			    }
			}
		    }
    break;

  case 49:
/* Line 1787 of yacc.c  */
#line 478 "gram.y"
    {
			indomspec_t	*ip;
			for (ip = walk_indom(W_START); ip != NULL; ip = walk_indom(W_NEXT)) {
			    if (change_inst_by_name(ip->old_indom, (yyvsp[(2) - (4)].str), (yyvsp[(4) - (4)].str)) < 0)
				yyerror(mess);
			}
			free((yyvsp[(2) - (4)].str));
			/* Note: $4 referenced from new_iname[] */
		    }
    break;

  case 50:
/* Line 1787 of yacc.c  */
#line 488 "gram.y"
    {
			indomspec_t	*ip;
			for (ip = walk_indom(W_START); ip != NULL; ip = walk_indom(W_NEXT)) {
			    if (change_inst_by_name(ip->old_indom, (yyvsp[(2) - (4)].str), NULL) < 0)
			    	yyerror(mess);
			}
			free((yyvsp[(2) - (4)].str));
		    }
    break;

  case 51:
/* Line 1787 of yacc.c  */
#line 497 "gram.y"
    {
			indomspec_t	*ip;
			for (ip = walk_indom(W_START); ip != NULL; ip = walk_indom(W_NEXT)) {
			    if (change_inst_by_inst(ip->old_indom, (yyvsp[(2) - (4)].ival), (yyvsp[(4) - (4)].ival)) < 0)
				yyerror(mess);
			}
		    }
    break;

  case 52:
/* Line 1787 of yacc.c  */
#line 505 "gram.y"
    {
			indomspec_t	*ip;
			for (ip = walk_indom(W_START); ip != NULL; ip = walk_indom(W_NEXT)) {
			    if (change_inst_by_inst(ip->old_indom, (yyvsp[(2) - (4)].ival), PM_IN_NULL) < 0)
				yyerror(mess);
			}
		    }
    break;

  case 53:
/* Line 1787 of yacc.c  */
#line 513 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting <domain>.<serial> or <domain>.* in indom clause");
			yyerror(mess);
		    }
    break;

  case 54:
/* Line 1787 of yacc.c  */
#line 518 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting -> in indom clause");
			yyerror(mess);
		    }
    break;

  case 55:
/* Line 1787 of yacc.c  */
#line 523 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting new external instance name string or DELETE in iname clause");
			yyerror(mess);
		    }
    break;

  case 56:
/* Line 1787 of yacc.c  */
#line 528 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting -> in iname clause");
			yyerror(mess);
		    }
    break;

  case 57:
/* Line 1787 of yacc.c  */
#line 533 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting old external instance name string in iname clause");
			yyerror(mess);
		    }
    break;

  case 58:
/* Line 1787 of yacc.c  */
#line 538 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting new internal instance identifier or DELETE in inst clause");
			yyerror(mess);
		    }
    break;

  case 59:
/* Line 1787 of yacc.c  */
#line 543 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting -> in inst clause");
			yyerror(mess);
		    }
    break;

  case 60:
/* Line 1787 of yacc.c  */
#line 548 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting old internal instance identifier in inst clause");
			yyerror(mess);
		    }
    break;

  case 61:
/* Line 1787 of yacc.c  */
#line 555 "gram.y"
    {
			if (current_star_metric) {
			    __pmContext		*ctxp;
			    __pmHashCtl		*hcp;
			    __pmHashNode	*this;
			    ctxp = __pmHandleToPtr(pmWhichContext());
			    assert(ctxp != NULL);
			    hcp = &ctxp->c_archctl->ac_log->l_hashpmid;
			    star_domain = pmid_domain((yyvsp[(2) - (2)].pmid));
			    if (current_star_metric == 1)
				star_cluster = pmid_cluster((yyvsp[(2) - (2)].pmid));
			    else
				star_cluster = PM_ID_NULL;
			    for (this = __pmHashWalk(hcp, W_START); this != NULL; this = __pmHashWalk(hcp, W_NEXT)) {
				if (pmid_domain((pmID)(this->key)) == star_domain &&
				    (star_cluster == PM_ID_NULL ||
				     star_cluster == pmid_cluster((pmID)(this->key))))
				    current_metricspec = start_metric((pmID)(this->key));
			    }
			    do_walk_metric = 1;
			}
			else {
			    if ((yyvsp[(2) - (2)].pmid) == PM_ID_NULL)
				/* metric not in archive */
				current_metricspec = NULL;
			    else
				current_metricspec = start_metric((yyvsp[(2) - (2)].pmid));
			    do_walk_metric = 0;
			}
		    }
    break;

  case 63:
/* Line 1787 of yacc.c  */
#line 587 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting metric name or <domain>.<cluster>.<item> or <domain>.<cluster>.* or <domain>.*.* in metric rule");
			yyerror(mess);
		    }
    break;

  case 65:
/* Line 1787 of yacc.c  */
#line 595 "gram.y"
    {
			int	sts;
			pmID	pmid;
			sts = pmLookupName(1, &(yyvsp[(1) - (1)].str), &pmid);
			if (sts < 0) {
			    if (wflag) {
				snprintf(mess, sizeof(mess), "Metric: %s: %s", (yyvsp[(1) - (1)].str), pmErrStr(sts));
				yywarn(mess);
			    }
			    pmid = PM_ID_NULL;
			}
			current_star_metric = 0;
			free((yyvsp[(1) - (1)].str));
			(yyval.pmid) = pmid;
		    }
    break;

  case 66:
/* Line 1787 of yacc.c  */
#line 613 "gram.y"
    {
			int	domain;
			int	cluster;
			int	item;
			int	sts;
			sts = sscanf((yyvsp[(1) - (1)].str), "%d.%d.%d", &domain, &cluster, &item);
			assert(sts == 3);
			if (domain < 1 || domain >= DYNAMIC_PMID) {
			    snprintf(mess, sizeof(mess), "Illegal domain field (%d) for pmid", domain);
			    yyerror(mess);
			}
			if (cluster < 0 || cluster >= 4096) {
			    snprintf(mess, sizeof(mess), "Illegal cluster field (%d) for pmid", cluster);
			    yyerror(mess);
			}
			if (item < 0 || item >= 1024) {
			    snprintf(mess, sizeof(mess), "Illegal item field (%d) for pmid", item);
			    yyerror(mess);
			}
			current_star_metric = 0;
			free((yyvsp[(1) - (1)].str));
			(yyval.pmid) = pmid_build(domain, cluster, item);
		    }
    break;

  case 67:
/* Line 1787 of yacc.c  */
#line 637 "gram.y"
    {
			int	domain;
			int	cluster;
			int	sts;
			sts = sscanf((yyvsp[(1) - (1)].str), "%d.%d.", &domain, &cluster);
			if (domain < 1 || domain >= DYNAMIC_PMID) {
			    snprintf(mess, sizeof(mess), "Illegal domain field (%d) for pmid", domain);
			    yyerror(mess);
			}
			if (sts == 2) {
			    if (cluster >= 4096) {
				snprintf(mess, sizeof(mess), "Illegal cluster field (%d) for pmid", cluster);
				yyerror(mess);
			    }
			    current_star_metric = 1;
			}
			else {
			    cluster = 0;
			    current_star_metric = 2;
			}
			free((yyvsp[(1) - (1)].str));
			(yyval.pmid) = pmid_build(domain, cluster, 0);
		    }
    break;

  case 72:
/* Line 1787 of yacc.c  */
#line 671 "gram.y"
    {
			metricspec_t	*mp;
			pmID		pmid;
			for (mp = walk_metric(W_START, METRIC_CHANGE_PMID, "pmid"); mp != NULL; mp = walk_metric(W_NEXT, METRIC_CHANGE_PMID, "pmid")) {
			    if (current_star_metric == 1)
				pmid = pmid_build(pmid_domain((yyvsp[(3) - (3)].pmid)), pmid_cluster((yyvsp[(3) - (3)].pmid)), pmid_item(mp->old_desc.pmid));
			    else if (current_star_metric == 2)
				pmid = pmid_build(pmid_domain((yyvsp[(3) - (3)].pmid)), pmid_cluster(mp->old_desc.pmid), pmid_item(mp->old_desc.pmid));
			    else
				pmid = (yyvsp[(3) - (3)].pmid);
			    if (pmid == mp->old_desc.pmid) {
				/* no change ... */
				if (wflag) {
				    snprintf(mess, sizeof(mess), "Metric: %s (%s): pmid: No change", mp->old_name, pmIDStr(mp->old_desc.pmid));
				    yywarn(mess);
				}
			    }
			    else {
				mp->new_desc.pmid = pmid;
				mp->flags |= METRIC_CHANGE_PMID;
			    }
			}
		    }
    break;

  case 73:
/* Line 1787 of yacc.c  */
#line 695 "gram.y"
    {
			metricspec_t	*mp;
			for (mp = walk_metric(W_START, METRIC_CHANGE_NAME, "name"); mp != NULL; mp = walk_metric(W_NEXT, METRIC_CHANGE_NAME, "name")) {
			    if (strcmp((yyvsp[(3) - (3)].str), mp->old_name) == 0) {
				/* no change ... */
				if (wflag) {
				    snprintf(mess, sizeof(mess), "Metric: %s (%s): name: No change", mp->old_name, pmIDStr(mp->old_desc.pmid));
				    yywarn(mess);
				}
			    }
			    else {
				int	sts;
				pmID	pmid;
				sts = pmLookupName(1, &(yyvsp[(3) - (3)].str), &pmid);
				if (sts >= 0) {
				    snprintf(mess, sizeof(mess), "Metric name %s already assigned for PMID %s", (yyvsp[(3) - (3)].str), pmIDStr(pmid));
				    yyerror(mess);
				}
				mp->new_name = (yyvsp[(3) - (3)].str);
				mp->flags |= METRIC_CHANGE_NAME;
			    }
			}
		    }
    break;

  case 74:
/* Line 1787 of yacc.c  */
#line 719 "gram.y"
    {
			metricspec_t	*mp;
			for (mp = walk_metric(W_START, METRIC_CHANGE_TYPE, "type"); mp != NULL; mp = walk_metric(W_NEXT, METRIC_CHANGE_TYPE, "type")) {
			    if ((yyvsp[(3) - (3)].ival) == mp->old_desc.type) {
				/* no change ... */
				if (wflag) {
				    snprintf(mess, sizeof(mess), "Metric: %s (%s): type: PM_TYPE_%s: No change", mp->old_name, pmIDStr(mp->old_desc.pmid), pmTypeStr(mp->old_desc.type));
				    yywarn(mess);
				}
			    }
			    else {
				if (mp->old_desc.type == PM_TYPE_32 ||
				    mp->old_desc.type == PM_TYPE_U32 ||
				    mp->old_desc.type == PM_TYPE_64 ||
				    mp->old_desc.type == PM_TYPE_U64 ||
				    mp->old_desc.type == PM_TYPE_FLOAT ||
				    mp->old_desc.type == PM_TYPE_DOUBLE) {
				    mp->new_desc.type = (yyvsp[(3) - (3)].ival);
				    mp->flags |= METRIC_CHANGE_TYPE;
				}
				else {
				    snprintf(mess, sizeof(mess), "Old type (PM_TYPE_%s) must be numeric", pmTypeStr(mp->old_desc.type));
				    yyerror(mess);
				}
			    }
			}
		    }
    break;

  case 75:
/* Line 1787 of yacc.c  */
#line 747 "gram.y"
    {
			metricspec_t	*mp;
			pmInDom		indom;
			for (mp = walk_metric(W_START, METRIC_CHANGE_INDOM, "indom"); mp != NULL; mp = walk_metric(W_NEXT, METRIC_CHANGE_INDOM, "indom")) {
			    if (current_star_indom)
				indom = pmInDom_build(pmInDom_domain((yyvsp[(3) - (4)].indom)), pmInDom_serial(mp->old_desc.indom));
			    else
				indom = (yyvsp[(3) - (4)].indom);
			    if (indom == mp->old_desc.indom) {
				/* no change ... */
				if (wflag) {
				    snprintf(mess, sizeof(mess), "Metric: %s (%s): indom: %s: No change", mp->old_name, pmIDStr(mp->old_desc.pmid), pmInDomStr(mp->old_desc.indom));
				    yywarn(mess);
				}
			    }
			    else {
				if ((output == OUTPUT_MIN ||
					  output == OUTPUT_MAX ||
					  output == OUTPUT_SUM ||
					  output == OUTPUT_AVG) &&
					 mp->old_desc.type != PM_TYPE_32 &&
					 mp->old_desc.type != PM_TYPE_U32 &&
					 mp->old_desc.type != PM_TYPE_64 &&
					 mp->old_desc.type != PM_TYPE_U64 &&
					 mp->old_desc.type != PM_TYPE_FLOAT &&
					 mp->old_desc.type != PM_TYPE_DOUBLE) {
				    snprintf(mess, sizeof(mess), "OUTPUT option MIN, MAX, AVG or SUM requires type to be numeric, not PM_TYPE_%s", pmTypeStr(mp->old_desc.type));
				    yyerror(mess);
				}
				mp->new_desc.indom = indom;
				mp->flags |= METRIC_CHANGE_INDOM;
				mp->output = output;
				if (output == OUTPUT_ONE) {
				    mp->one_name = one_name;
				    mp->one_inst = one_inst;
				    if (mp->old_desc.indom == PM_INDOM_NULL)
					/*
					 * singular input, pick first (only)
					 * value, not one_inst matching ...
					 * one_inst used for output instance
					 * id
					 */
					mp->output = OUTPUT_FIRST;
				}
				if (output == OUTPUT_ALL) {
				    /*
				     * No OUTPUT clause, set up the defaults
				     * based on indom types:
				     * non-NULL -> NULL
				     *		OUTPUT_FIRST, inst PM_IN_NULL
				     * NULL -> non-NULL
				     *		OUTPUT_FIRST, inst 0
				     * non-NULL -> non-NULL
				     * 		all instances selected
				     *		(nothing to do for defaults)
				     * NULL -> NULL
				     *		caught above in no change case
				     */
				    if (mp->old_desc.indom != PM_INDOM_NULL &&
				        mp->new_desc.indom == PM_INDOM_NULL) {
					mp->output = OUTPUT_FIRST;
					mp->one_inst = PM_IN_NULL;
				    }
				    else if (mp->old_desc.indom == PM_INDOM_NULL &&
				             mp->new_desc.indom != PM_INDOM_NULL) {
					mp->output = OUTPUT_FIRST;
					mp->one_inst = 0;
				    }
				}
			    }
			}
			output = OUTPUT_ALL;	/* for next time */
		    }
    break;

  case 76:
/* Line 1787 of yacc.c  */
#line 821 "gram.y"
    {
			metricspec_t	*mp;
			for (mp = walk_metric(W_START, METRIC_CHANGE_SEM, "sem"); mp != NULL; mp = walk_metric(W_NEXT, METRIC_CHANGE_SEM, "sem")) {
			    if ((yyvsp[(3) - (3)].ival) == mp->old_desc.sem) {
				/* no change ... */
				if (wflag) {
				    snprintf(mess, sizeof(mess), "Metric: %s (%s): sem: %s: No change", mp->old_name, pmIDStr(mp->old_desc.pmid), SemStr(mp->old_desc.sem));
				    yywarn(mess);
				}
			    }
			    else {
				mp->new_desc.sem = (yyvsp[(3) - (3)].ival);
				mp->flags |= METRIC_CHANGE_SEM;
			    }
			}
		    }
    break;

  case 77:
/* Line 1787 of yacc.c  */
#line 838 "gram.y"
    {
			metricspec_t	*mp;
			for (mp = walk_metric(W_START, METRIC_CHANGE_UNITS, "units"); mp != NULL; mp = walk_metric(W_NEXT, METRIC_CHANGE_UNITS, "units")) {
			    if ((yyvsp[(3) - (14)].ival) == mp->old_desc.units.dimSpace &&
			        (yyvsp[(5) - (14)].ival) == mp->old_desc.units.dimTime &&
			        (yyvsp[(7) - (14)].ival) == mp->old_desc.units.dimCount &&
			        (yyvsp[(9) - (14)].ival) == mp->old_desc.units.scaleSpace &&
			        (yyvsp[(11) - (14)].ival) == mp->old_desc.units.scaleTime &&
			        (yyvsp[(13) - (14)].ival) == mp->old_desc.units.scaleCount) {
				/* no change ... */
				if (wflag) {
				    snprintf(mess, sizeof(mess), "Metric: %s (%s): units: %s: No change", mp->old_name, pmIDStr(mp->old_desc.pmid), pmUnitsStr(&mp->old_desc.units));
				    yywarn(mess);
				}
			    }
			    else {
				mp->new_desc.units.dimSpace = (yyvsp[(3) - (14)].ival);
				mp->new_desc.units.dimTime = (yyvsp[(5) - (14)].ival);
				mp->new_desc.units.dimCount = (yyvsp[(7) - (14)].ival);
				mp->new_desc.units.scaleSpace = (yyvsp[(9) - (14)].ival);
				mp->new_desc.units.scaleTime = (yyvsp[(11) - (14)].ival);
				mp->new_desc.units.scaleCount = (yyvsp[(13) - (14)].ival);
				mp->flags |= METRIC_CHANGE_UNITS;
				if ((yyvsp[(14) - (14)].ival) == 1) {
				    if ((yyvsp[(3) - (14)].ival) == mp->old_desc.units.dimSpace &&
					(yyvsp[(5) - (14)].ival) == mp->old_desc.units.dimTime &&
					(yyvsp[(7) - (14)].ival) == mp->old_desc.units.dimCount)
					/* OK, no dim changes */
					mp->flags |= METRIC_RESCALE;
				    else {
					if (wflag) {
					    snprintf(mess, sizeof(mess), "Metric: %s (%s): Dimension changed, cannot rescale", mp->old_name, pmIDStr(mp->old_desc.pmid));
					    yywarn(mess);
					}
				    }
				}
				else if (sflag) {
				    if ((yyvsp[(3) - (14)].ival) == mp->old_desc.units.dimSpace &&
					(yyvsp[(5) - (14)].ival) == mp->old_desc.units.dimTime &&
					(yyvsp[(7) - (14)].ival) == mp->old_desc.units.dimCount)
					mp->flags |= METRIC_RESCALE;
				}
			    }
			}
		    }
    break;

  case 78:
/* Line 1787 of yacc.c  */
#line 884 "gram.y"
    {
			metricspec_t	*mp;
			for (mp = walk_metric(W_START, METRIC_DELETE, "delete"); mp != NULL; mp = walk_metric(W_NEXT, METRIC_DELETE, "delete")) {
			    mp->flags |= METRIC_DELETE;
			}
		    }
    break;

  case 79:
/* Line 1787 of yacc.c  */
#line 891 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting <domain>.<cluster>.<item> or <domain>.<cluster>.* or <domain>.*.* in pmid clause");
			yyerror(mess);
		    }
    break;

  case 80:
/* Line 1787 of yacc.c  */
#line 896 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting metric name in iname clause");
			yyerror(mess);
		    }
    break;

  case 81:
/* Line 1787 of yacc.c  */
#line 901 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting XXX (from PM_TYPE_XXX) in type clause");
			yyerror(mess);
		    }
    break;

  case 82:
/* Line 1787 of yacc.c  */
#line 906 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting <domain>.<serial> or NULL in indom clause");
			yyerror(mess);
		    }
    break;

  case 83:
/* Line 1787 of yacc.c  */
#line 911 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting XXX (from PM_SEM_XXX) in sem clause");
			yyerror(mess);
		    }
    break;

  case 84:
/* Line 1787 of yacc.c  */
#line 916 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting 3 numeric values for dim* fields of units");
			yyerror(mess);
		    }
    break;

  case 85:
/* Line 1787 of yacc.c  */
#line 921 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting 0 or XXX (from PM_SPACE_XXX) for scaleSpace field of units");
			yyerror(mess);
		    }
    break;

  case 86:
/* Line 1787 of yacc.c  */
#line 926 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting 0 or XXX (from PM_TIME_XXX) for scaleTime field of units");
			yyerror(mess);
		    }
    break;

  case 87:
/* Line 1787 of yacc.c  */
#line 931 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting 0 or ONE for scaleCount field of units");
			yyerror(mess);
		    }
    break;

  case 89:
/* Line 1787 of yacc.c  */
#line 939 "gram.y"
    {
			(yyval.indom) = PM_INDOM_NULL;
		    }
    break;

  case 90:
/* Line 1787 of yacc.c  */
#line 945 "gram.y"
    {
			output = OUTPUT_ONE;
			one_inst = (yyvsp[(3) - (3)].ival);
			one_name = NULL;
		    }
    break;

  case 91:
/* Line 1787 of yacc.c  */
#line 951 "gram.y"
    {
			output = OUTPUT_ONE;
			one_inst = PM_IN_NULL;
			one_name = (yyvsp[(3) - (3)].str);
		    }
    break;

  case 92:
/* Line 1787 of yacc.c  */
#line 957 "gram.y"
    {
			output = (yyvsp[(2) - (2)].ival);
		    }
    break;

  case 93:
/* Line 1787 of yacc.c  */
#line 961 "gram.y"
    {
			snprintf(mess, sizeof(mess), "Expecting FIRST or LAST or INST or INAME or MIN or MAX or AVG for OUTPUT instance option");
			yyerror(mess);
		    }
    break;

  case 95:
/* Line 1787 of yacc.c  */
#line 968 "gram.y"
    { (yyval.ival) = 1; }
    break;

  case 96:
/* Line 1787 of yacc.c  */
#line 970 "gram.y"
    { (yyval.ival) = 0; }
    break;


/* Line 1787 of yacc.c  */
#line 2663 "gram.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2048 of yacc.c  */
#line 973 "gram.y"


